
import collections
from . import globalVariable as g


def transform_ordered_syscode(syscode, number_qubits, **kwargs):
	'''
		개별 게이트의 circuit index를 분석하고, 시간순으로 정리된 회로를 생성 리턴하는 함
	'''

	
	time_index = collections.defaultdict(int)
	ordered_syscode = collections.defaultdict(list)
	
	for inst in syscode:
		if inst[0] in [g.str_gate_cnot, g.str_gate_cz, g.str_gate_swap]:
			ctrl, trgt = inst[1:]

			applying_index = max(time_index[ctrl], time_index[trgt])
			time_index[ctrl] = time_index[trgt] = applying_index+1
			list_command = "{} {},{}".format(inst[0], ctrl, trgt)
			
		else: 
			if inst[0] in [g.str_gate_rz, g.str_gate_rx, g.str_gate_ry, g.str_gate_phase]:
				angle, qubit = inst[1:]
				list_command = "{}({}) {}".format(inst[0], angle, qubit)
			
			elif inst[0] in [g.str_gate_u]:
				angle_x, angle_y, angle_z, qubit = inst[1:]
				list_command = "{}({},{},{}) {}".format(inst[0], angle_x, angle_y, angle_z, qubit)

			elif inst[0] in [g.str_gate_measz, g.str_gate_measx]:
				qubit, cbit, *arguments = inst[1:]
				list_str_command = [inst[0], str(qubit), "->", str(cbit)]
				
				list_command = " ".join(list_str_command)

			elif inst[0] in ["Qubit"]:
				if len(inst[1:]) == 2:
					qubit, size = inst[1:]
					list_command = "{} {} {}".format(inst[0], qubit, size)
				else:
					qubit = inst[1]
					list_command = "{} {}".format(inst[0], qubit)
			else:
				qubit = inst[1]
				list_command = "{} {}".format(inst[0], qubit)
				
			applying_index = time_index[qubit]
			time_index[qubit] += 1

		ordered_syscode[applying_index].append(list_command)

	return ordered_syscode
